## Running LIGRA benchmark on gem5 with RISC-V ISA 

* Reference : [Simulating Multi-Core RISC-V Systems in gem5](http://www.csl.cornell.edu/~cbatten/pdfs/ta-gem5-riscv-carrv2018.pdf)
 
## Commands:
* To run benchmarks from the LIGRA graph workload suite over a 16-core RISCV system
```bash
$ scons build/RISCV_MESI_Two_Level/gem5.fast -j9

$ ./build/RISCV_MESI_Two_Level/gem5.fast --outdir my_STATS/RISCV_64c_MESI_BFS_L1-1kB_L2-4kB_VC-4_tr-1 configs/example/se.py --cpu-type=TimingSimpleCPU --num-cpus=16 --num-l2caches=16 --l1d_size=1kB --l1i_size=1kB --l1d_assoc=2 --l1i_assoc=2 --l2_size=4kB --l2_assoc=8 \
--num-dirs=16 --mem-size=4096MB --ruby --network=garnet2.0  --topology=Mesh_XY --mesh-rows=4 --vcs-per-vnet=4 --router-latency=1 --maxinsts=100000 -c my_benchmarks/ligra/bin/riscv/BFS -o '-n 16 my_benchmarks/ligra/input/rMatGraph_J_5_100'
```
* **Following is the elucidation on some important parameters used :-**
* outdir : it specifies the output directory where the default statistics will be written
* configs/example/se.py : Choosing system emulation mode
* cpu-type : Specify the cpu model
* num-cpus : Specify the number of injector's in NoC
* num-l2caches=16 : specify the number of banks for L2 cache
* l1d_size : Size of L1 data cache
* l1i_size : Size of L1 instruction cache
* l2_assoc : Specify the number of ways in one set of L2 cache
* l1d_assoc : Specify the number of ways in one set of L1 data cache
* l1i_assoc : Specify the number of ways in one set of L1 instruction cache
* num-dirs : Specify the number of ejector's (ejection nodes) in NoC
* mem-size : Specify the main memory size (DRAM)
* maxinsts : Maximum number of instructions to run before the simulation ends
* router-latency=1 : Specify the router latency. Here, 1 cycle router is chosen.
* -c my_benchmarks/ligra/bin/riscv/BFS : specify the benchmark application for simulation
* topology=Mesh_XY : Specify the routing algorithm

## Running benchmark on Lo_Hi NoC ( NoC with criticality at VC level) : 
1. To change the arbitration related files: 
```bash
$ pushd src/mem/ruby/network/garnet2.0/
$ ./scripts/launch_lo_hi.sh
$ pushd
```
2. Build gem5: 
```bash
$ scons build/RISCV_MESI_Two_Level/gem5.fast -j9
```
3. Run simulation : 
```bash
$ rm -rf lat
$ mkdir lat
$ ./build/RISCV_MESI_Two_Level/gem5.fast --outdir my_STATS/RISCV_64c_MESI_BFS_L1-1kB_L2-4kB_VC-4_tr-1 configs/example/se.py --cpu-type=TimingSimpleCPU --num-cpus=16 --num-l2caches=16 --l1d_size=1kB --l1i_size=1kB --l1d_assoc=2 --l1i_assoc=2 --l2_size=4kB --l2_assoc=8 \
--num-dirs=16 --mem-size=4096MB --ruby --network=garnet2.0  --topology=Mesh_XY --mesh-rows=4 --vcs-per-vnet=4 --router-latency=1 --maxinsts=100000 -c my_benchmarks/ligra/bin/riscv/BFS -o '-n 16 my_benchmarks/ligra/input/rMatGraph_J_5_100'
```
*  **NOTE:** 'lat' directory stores the latency values for each VCid where packet gets ejected. These files are generated by NetworkInterface.cc for a default value of vcs_per_vnet = 4.
4. To generate statistics: copy the required python scripts present in " experiments/exp4/python_scripts/ __file__name " to gem5 directory. For example : 
```bash
$ cp experiments/exp4/python_scripts/avg_lat.py ./
$ python3 avg_lat.py
```
*  **NOTE:** Details about all the statistics generating python scripts is provided in "experiments/exp4/python_scripts" directory.
5. To change the arbitration policy back to baseline_garnet: 
```bash
$ pushd
$ ./launch_baseline.sh
$ pushd
```
* **NOTE:** One needs to rebuild gem5 after changing any of the source files, to reflect the modifications. Use : (2) and (3)

---

## Observations and Results:
* Following files describe statistics (like average packet latency, maximum packet latency, total packets, etc for each VCid where packet gets ejected):
    1. ``baseline_benchmark.txt`` : for baseline garnet   
    2. ``lo_hi_benchmark.txt`` : scheme with criticality assigned at VCs for each VNET

* Number of packets ejected from each VCid : 
* | VCid | Criticality |Packets ejected_baseline|Packets ejected_lo_hi|
  | ---  |  ------  |---------------------------|---------------------| 
  | VC0   | HI   |19064|10316|
  | VC1   | HI   |2961|743|
  | VC2   | LO   |13|10236|
  | VC3   | LO   |2|784|
  | VC4   | HI   |23956|13273|
  | VC5   | HI   |4507|1461|
  | VC6   | LO   |591|13086|
  | VC7   | LO   |199|1505|
  | VC8   | HI   |9515|4849|
  | VC9   | HI   |189|42|
  | VC10   | LO   |15|4810|
  | VC11   | LO   |0|49|

* **Few are notable observations :** 
    1. There are three message classes for MESI cache coherence policy in garnet.
    
    2. There is a pattern for number of packets getting ejected in baseline case : Major chunk of packets are getting ejected from VC0, VC4 and VC8 in their respective VNETS 0, 1 2, however VC3, VC7 and VC11 have the lowest packets. This suggests
       that the network is having a low load/traffic generated by running BFS application.
    
    3. In the lo_hi network, significantly high number of packets travel from VC2, VC6 and VC10 (close to VC0, VC4, VC8). A possible reason for this : a packet getting injected into 
       VC0 has only VC0 and VC1 buffers available for network traversal. So, when injector finds VC0,VC1 occupied, it injects into VC2, VC3. Comparing from baseline where
       a packet was able to reside in any of the 4 VCs during its network traversal, there is limited buffers(actally 2) available in the lo_hi case.
    
    4. Comparing average latency values of VNET0 of baseline(11.4) and VC0,VC1 of lo_hi(11.22) : there is a little improvement. 
    
    5. Comparing maximum latency values of VNET0 of baseline(28) and VC0, VC1 of lo_hi(23): the tail latency is decreased.
    
    6. The pattern mentioned in (2) and the gap between average latency value and maximum latency value of baseline statistics suggests, that that the network is operating 
       under low load injection for all VNETs.

    7. Unlike stress testing the network using synthetic traffic with dummy cache coherence policy, here different VNETs observe different injection rates.

*  **WIP : Further evaluations:**
    1. For a cache coherence policy, number of message classes / VNETs created.
    2. Packet Size of each message class for a MESI cache coherence policy.
    3. Characteristic : comparing injection rate of different message classes as a measure to compare different applications.
    4. Characteristic : comparing (3) individually for all the 16 nodes in network.